QGIS Application - Bug report #6257
db manager fails to import all features from shapefile to spatialite
2012-08-27 12:33 PM - Etienne Tourigny

Status: Closed

Priority: Normal

Assignee: Giuseppe Sucameli

Category: Data Provider/SpatialLite

Affected QGIS version:master Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 15563
Description

when dropping layer from file manager to spatialite file in browser, not all features are copied. This happens in both 1.8 and master

However, import is fine when using gspatialite plugin.

The error given when using 1.8 is

Failed to import some layers!

clas_226_67_20100724_pol: Feature write errors:

Creation error for features from #200 to #281. Provider errors was:

SQLite error: constraint failed

SQL: INSERT INTO "clas_226_67_20100724_pol"("pk","geomm","sprarea","sprperimet","sprclasse") VALUES
(NULL,GeomFromWKB(?, 4326),?,7,7)

Only 200 of 282 features written.

in master:

Failed to import some layers!

clas_226_67_20100724_pol: Feature write errors:

Creation error for features from #0 to #0. Provider errors was:

SQLite error: constraint failed

SQL: INSERT INTO "clas_226_67_20100724_pol"("geomm","sprarea”,"sprperimet","sprclasse") VALUES (GeomFromWKB(?,
4326),?,7,7)

Only 200 of 282 features written.

ogrinfo on the file:

$ ogrinfo -so clas_226_67_20100724_pol.shp clas_226_67_20100724_pol
INFO: Open of ‘clas_226_67_20100724_pol.shp'
using driver 'ESRI Shapefile’ successful.

Layer name: clas_226_67_20100724_pol

Geometry: Polygon

Feature Count: 282

Extent: (687536.000000, 8806300.000000) - (886580.000000, 8975017.000000)

2025-12-22 1/3




Layer SRS WKT:
(unknown)

SPRAREA: Real (20.4)
SPRPERIMET: Real (20.4)
SPRCLASSE: String (32.0)

| get a similar error with a larger file

Failed to import some layers!

clas_226_67_20101012_pol: Feature write errors:

Creation error for features from #3600 to #3799. Provider errors was:

SQLite error: constraint failed

SQL: INSERT INTO "clas_226_67_20101012_pol"("pk","geomm","sprarea","sprperimet","sprclasse") VALUES

(NULL,GeomFromWKB(?, 4326),?,2,?)

Creation error for features from #3800 to #3999. Provider errors was:

SQLite error: constraint failed

SQL: INSERT INTO "clas_226_67_20101012_pol"("pk","geomm","sprarea","sprperimet","sprclasse") VALUES

(NULL,GeomFromWKB(?, 4326),2,?,?)

Creation error for features from #4000 to #4148. Provider errors was:

SQLite error: constraint failed

SQL: INSERT INTO "clas_226_67_20101012_pol"("pk","geomm","sprarea","sprperimet","sprclasse") VALUES

(NULL,GeomFromWKB(?, 4326),?,?,7)
Only 3600 of 4149 features written.

Associated revisions

Revision 1bde6c58 - 2012-12-05 07:16 PM - Giuseppe Sucameli

SL provider: convert geometries to multipart when necessary (fix #6257)

History

#1 - 2012-08-28 03:08 PM - Giovanni Manghi
- Operating System deleted (linux)

- Assignee set to Giuseppe Sucameli

#2 - 2012-09-04 12:07 PM - Paolo Cavallini
- Target version set to Version 2.0.0

#3 - 2012-11-29 07:17 AM - Giuseppe Sucameli
- Category changed from DB Manager to Data Provider/SpatiaLite
- Status changed from Open to In Progress

The SL provider doesn't convert geometries to multipart when needed (i.e. when the layer has a multipart type).

Somehow related to #5547 because the problem usually occurs importing shapefiles.

#4 - 2012-11-29 07:41 AM - Giuseppe Sucameli
Giuseppe Sucameli wrote:

The SL provider doesn't convert geometries to multipart when needed (i.e. when the layer has a multipart type).

The AddGeometryColumn spatialite function adds triggers to check the geometry type and srid of new/changed geometries but the constraint fails trying to

add a singlepart geometry to a spatial table with a multipart geometry type.

The ST_Multi function is available for SL >= 2.4.0, so we have to handle it to avoid to get a "no such function" error working on older DBs.

#5 - 2012-12-05 11:07 AM - Giuseppe Sucameli
- Status changed from In Progress to Closed

Fixed in changeset commit:"1bde6c58df3ed73e200e98809ab508e6d6b62d38".

Files

clas_226_67_20100724_pol.zip 114 KB 2012-08-27 Etienne Tourigny
